
package com.topcoder.message.im.profile;
import com.topcoder.message.im.profile.ContactComparatorBase;

/**
 * <p>ContactGroup represents a group that holds multiple contacts. Groups can have sub groups. ContactGroup subclasses MessagingObject. For this release ContactGroup only has a group name. Except from manipulating methods it also provides the functionality to sort contacts and sub groups, with the help of ContactComparatorBase.</p>
 * 
 */
public class ContactGroup extends com.topcoder.message.im.MessagingObject {

/**
 * <p>The name of the contact group. It is mutable with setter and getter.</p>
 * 
 */
    private String groupName = null;

/**
 * <p>Contacts in this group. One contact can belong to multiple groups. It is initialized to an ArrayList and manipulated in various methods related to contacts.</p>
 * 
 */
    private java.util.List contacts = new ArrayList();

/**
 * <p>Sub groups in this group. One sub group can belong to multiple groups. It is initialized to an ArrayList and manipulated with various methods related to sub groups.</p>
 * 
 */
    private java.util.List subGroups = ArrayList();
/**
 * <p></p>
 * 
 * @poseidon-type com.topcoder.message.im.profile.Contact
 */
    public java.util.Collection contact = new java.util.TreeSet();

/**
 * <p>Create instance with group name. Set it to the field.</p>
 * 
 * 
 * 
 * 
 * @param groupName the group name
 * @exception NullPointerException if groupName is null
 * @exception IllegalArgumentException if groupName is empty
 */
    public  ContactGroup(String groupName) {        
        // your code here
    } 

/**
 * <p>Set the group name.</p>
 * 
 * 
 * 
 * 
 * @param groupName the group name
 * @exception NullPointerException if groupName is null
 * @exception IllegalArgumentException if groupName is empty
 */
    public void setGroupName(String groupName) {        
        // your code here
    } 

/**
 * <p>Get the group name.</p>
 * 
 * 
 * 
 * 
 * @return the group name
 */
    public String getGroupName() {        
        // your code here
        return null;
    } 

/**
 * <p>Add a contact to the group.</p>
 * 
 * 
 * 
 * 
 * @param contact the contact to add
 * @exception NullPointerException if contact is null
 */
    public void addContact(com.topcoder.message.im.profile.Contact contact) {        
        // your code here
    } 

/**
 * <p>Remove the first contact with the given name from the group. If there are no contacts with that name null is returned.</p>
 * 
 * 
 * 
 * 
 * @return the removed contact instance or null if nothing removed
 * @param contactName the name of the contact to remove
 * @exception NullPointerException if contactName is null
 * @exception IllegalArgumentException if contactName is empty
 */
    public com.topcoder.message.im.profile.Contact removeContact(String contactName) {        
        // your code here
        return null;
    } 

/**
 * <p>Remove a contact from the group. Nothing happens if there is no such contact.</p>
 * 
 * 
 * 
 * 
 * @param contact the contact to remove
 * @exception NullPointerException if contact is null
 */
    public void removeContact(com.topcoder.message.im.profile.Contact contact) {        
        // your code here
    } 

/**
 * <p>Check whether the group contains at least one contact with the given name.</p>
 * 
 * 
 * 
 * 
 * @return whether the group contains such contact
 * @param contactName the contact name
 * @exception NullPointerException if contactName is null
 * @exception IllegalArgumentException if contactName is empty
 */
    public boolean containsContact(String contactName) {        
        // your code here
        return false;
    } 

/**
 * <p>Check whether the group contains the contact.</p>
 * 
 * 
 * 
 * 
 * @return whether the group contains the contact
 * @param contact the contact to check
 * @exception NullPointerException if contact is null
 */
    public boolean containsContact(com.topcoder.message.im.profile.Contact contact) {        
        // your code here
        return false;
    } 

/**
 * <p>Get contact with spelt name. If no contact is with that name return null. If multiple contact has that name return the first one.</p>
 * 
 * 
 * 
 * 
 * @return the contact instance or null if no such contact
 * @param contactName the contact name
 * @exception NullPointerException if contactName is null
 * @exception IllegalArgumentException if contactName is empty
 */
    public com.topcoder.message.im.profile.Contact getContact(String contactName) {        
        // your code here
        return null;
    } 

/**
 * <p>Get a list of all the contacts in this group. It does not return contacts in sub groups. Simply return a shallow copy of the contacts list.</p>
 * 
 * 
 * 
 * 
 * @return a shallow copy of the contacts
 */
    public java.util.List getAllContacts() {        
        // your code here
        return null;
    } 

/**
 * <p>Drop all the contacts.</p>
 * 
 * 
 * 
 */
    public void clearContacts() {        
        // your code here
    } 

/**
 * <p>Add a sub group to the group. One sub group can belong to multiple groups.</p>
 * <p>It is not required to check for cyclic reference. But if developer choose to implement it, IAE should be used.</p>
 * 
 * 
 * 
 * 
 * @param group the sub group to add
 * @exception NullPointerException if group is null
 */
    public void addSubGroup(com.topcoder.message.im.profile.ContactGroup group) {        
        // your code here
    } 

/**
 * <p>Remove the sub group with given name from the group. If no such group exists return null. If multiple sub groups exist return the first one.</p>
 * 
 * 
 * 
 * 
 * @return the removed sub group or null if nothing associated
 * @param groupName the group name to remove
 * @exception NullPointerException if groupName is null
 * @exception IllegalArgumentException if groupName is empty
 */
    public com.topcoder.message.im.profile.ContactGroup removeSubGroup(String groupName) {        
        // your code here
        return null;
    } 

/**
 * <p>Remove the sub group from the group. Nothing happens if it does not contain such sub group.</p>
 * 
 * 
 * 
 * 
 * @param group the sub group to remove
 * @exception NullPointerException if group is null
 */
    public void removeSubGroup(com.topcoder.message.im.profile.ContactGroup group) {        
        // your code here
    } 

/**
 * <p>Checks whether the group contains a sub group with given name.</p>
 * 
 * 
 * 
 * 
 * @return whether it contains sub group of the name
 * @param groupName the group name
 * @exception NullPointerException if groupName is null
 * @exception IllegalArgumentException if groupName is empty
 */
    public boolean containsSubGroup(com.topcoder.message.im.profile.ContactGroup.ContactGroup_ groupName) {        
        // your code here
        return false;
    } 

/**
 * <p>Checks whether the group contains specified sub group.</p>
 * 
 * 
 * 
 * 
 * @return whether it contains such sub group
 * @param group the group to check
 * @exception NullPointerException if group is null
 */
    public boolean containsSubGroup(com.topcoder.message.im.profile.ContactGroup group) {        
        // your code here
        return false;
    } 

/**
 * <p>Get sub group with given name. If no such group exists return null. If there are multiple return the first one.</p>
 * 
 * 
 * 
 * 
 * @return the sub group with that name or null if no such group
 * @param groupName the group name to locate
 * @exception NullPointerException if groupName is null
 * @exception IllegalArgumentException if groupName is empty
 */
    public com.topcoder.message.im.profile.ContactGroup getSubGroup(String groupName) {        
        // your code here
        return null;
    } 

/**
 * <p>Get all sub groups within the contact group. It simply returns a shallow copy of the subGroups field.</p>
 * 
 * 
 * 
 * 
 * @return shallow copy of the sub groups
 */
    public java.util.List getAllSubGroups() {        
        // your code here
        return null;
    } 

/**
 * <p>Drop all the sub groups.</p>
 * 
 * 
 * 
 */
    public void clearSubGroups() {        
        // your code here
    } 

/**
 * <p>Sort all the contacts with the comparator provided.</p>
 * 
 * 
 * 
 * 
 * @param comparator the sorting comparator
 * @exception NullPointerException if comparator is null
 */
    public void sortContacts(com.topcoder.message.im.profile.ContactComparatorBase comparator) {        
        // your code here
    } 

/**
 * <p>Sort all the sub groups with the comparator provided.</p>
 * 
 * 
 * 
 * 
 * @param comparator the sorting comparator
 * @exception NullPointerException if comparator is null
 */
    public void sortSubGroups(com.topcoder.message.im.profile.ContactComparatorBase comparator) {        
        // your code here
    } 

/**
 * <p>Sort all the contacts and subgroups recursively with the comparator provided.</p>
 * 
 * 
 * 
 * 
 * @param comparator the sorting comparator
 * @exception NullPointerException if comparator is null
 */
    public void sortRecursive(com.topcoder.message.im.profile.ContactComparatorBase comparator) {        
        // your code here
    } 
 }
