package com.topcoder.message.im.connection;

import java.net.Socket;

import com.topcoder.message.im.ConnectionStateException;
import com.topcoder.message.im.Message;
import com.topcoder.message.im.MessageSendingException;

public class MessageSender {
	
	/**
	 * The socket used to send the message. It is established in initializeConnection() and closed in closeConnection().
	 */
	private Socket socket = null;
	
	/**
	 * 
	 *  
	 * @param remoteAddress the remote address to connect to
	 * @param remotePort the remote port to connect to
	 * @param persistent
	 * 
	 * @exception NullPointerException if remoteAddress is null
	 * @exception IllegalArgumentException if listeningPort or remotePort is non positive or greater than max port number, or remoteAddress is not a valid address
	 */
	public MessageSender(String remoteAddress, int remotePort, boolean persistent) throws NullPointerException, IllegalArgumentException {		
	}
	
	/**
	 * Send a message to the remote socket. If connection is not open throw 
	 * ConnectionStateException. Otherwise write the message to the socket.
	 * 
	 * @param message the message to send
	 * 
	 * @exception NullPointerException if message is null
	 * @exception ConnectionStateException if connection is not open
	 * @exception MessageSendingException if message can not be properly sent
	 */
    public void sendMessage(Message message) throws NullPointerException, ConnectionStateException, MessageSendingException{                
    }

}
