package com.topcoder.message.im.server;

/**
 * A logon message that is used by clients to log on to the chat server.
 * It contains the user name and password.
 * The outcome of the logon is stored in errorMessage (null if ok). 
 */
public class LogonMessage extends com.topcoder.message.im.Message {
	
	/**
	 * <p>The content of the text, stored as a free form string, potentially with multiple lines. It is mutable and can be set in either constructor or with the setter.</p>
	 * 
	 */
	private String username = null;
	private String password = null;
	private String errorMessage = null;
	
	/**
	 * <p>Construct with the text. Set the text to the respective field.</p>
	 * 
	 * 
	 * 
	 * 
	 * @param text the text of the message
	 * @exception NullPointerException if text is null
	 */
	public LogonMessage(String username, String password) {        
		// your code here
	}
	
	/**
	 * <p>Construct with text, sender and a single recipient. Sets them separately to respective fields.</p>
	 * 
	 * 
	 * 
	 * 
	 * @param text the text of the message
	 * @param sender the sender of the message
	 * @param recipient the recipient of the message
	 * @exception NullPointerException if text or sender or recipient is null
	 */
	    public  LogonMessage(String username, String password, Object sender, Object recipient) {        
	        // your code here
	    } 

	/**
	 * <p>Construct with text, sender and multiple recipients. Set them to respective fields. Recipients list should not contain a null value.</p>
	 * 
	 * 
	 * 
	 * 
	 * @param text the text of the message
	 * @param sender the sender of the meesage
	 * @param recipients the recipients of the message
	 * @exception NullPointerException if text or sender or recipients is null
	 * @exception IllegalArgumentException if recipients contains null
	 */
	    public  LogonMessage(String username, String password, Object sender, java.util.List recipients) {        
	        // your code here
	    } 
	
	/**
	 * <p>Get the text of the message. Simply returns text.</p>
	 * 
	 * 
	 * 
	 * 
	 * @return the text of the message
	 */
	public String getUsername() {        
		// your code here
		return null;
	} 
	
	/**
	 * <p>Set the text of the message. Sets it to the text field.</p>
	 * 
	 * 
	 * 
	 * 
	 * @param text the text of the message
	 * @exception NullPointerException if text is null
	 */
	public void setUsername(String username) {        
		// your code here
	}
	
	/**
	 * <p>Get the text of the message. Simply returns text.</p>
	 * 
	 * 
	 * 
	 * 
	 * @return the text of the message
	 */
	public String getPassword() {        
		// your code here
		return null;
	} 
	
	/**
	 * <p>Set the text of the message. Sets it to the text field.</p>
	 * 
	 * 
	 * 
	 * 
	 * @param text the text of the message
	 * @exception NullPointerException if text is null
	 */
	public void setPassword(String username) {        
		// your code here
	} 

	/**
	 * @return Returns the errorMessage.
	 */
	public String getErrorMessage() {
		return errorMessage;
	}
	/**
	 * @param errorMessage The errorMessage to set.
	 */
	public void setErrorMessage(String errorMessage) {
		this.errorMessage = errorMessage;
	}
	
	/**
	 * 
	 * @return whether the logon was successful
	 */
	public boolean isLogonSuccessful() {
		return false;
	}
	
}
